// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Data.Caching;

namespace ApiDemo
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        private DataCache GetCurrentCache()
        {
            var factory = new DataCacheFactory();
            DataCache dCache = factory.GetCache("default");

            return dCache;
        }

        protected void addButton_Click(object sender, EventArgs e)
        {
            var dCache = GetCurrentCache();

            var key = keyTextbox.Text;
            var val = valueTxtBox.Text;

            if (key == "" || val == "") return;

            try
            {
                dCache.Add(key, val);
                statusLabel.Text =
                string.Format("Successfully added key {0} to cache.", key);
            }
            catch (Exception ex)
            {
                statusLabel.Text =
                    string.Format("Error adding key {0} to cache: {1}",
                    key, ex.Message);
            }

        }

        protected void putButton_Click(object sender, EventArgs e)
        {
            var dCache = GetCurrentCache();

            var key = keyTextbox.Text;
            var val = valueTxtBox.Text;

            if (key == "" || val == "") return;

            try
            {
                dCache.Put(key, val);
                statusLabel.Text =
                    string.Format("Successfully put key {0} to cache", key);
            }
            catch (Exception ex)
            {
                statusLabel.Text =
                    string.Format("Error putting key {0} to cache: {1}",
                    key, ex.Message);
            }

        }

        protected void getButton_Click(object sender, EventArgs e)
        {
            var dCache = GetCurrentCache();
            var key = keyTextbox.Text;

            if (key == "") return;

            try
            {
                var val = dCache.Get(key).ToString();
                valueTxtBox.Text = val;
                statusLabel.Text =
                string.Format("Successfully did Get of key {0} from cache",
                key);
            }
            catch (Exception ex)
            {
                statusLabel.Text =
                    string.Format("Error getting key {0} from cache: {1}",
                    key, ex.Message);
            }

        }

    }
}