// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Data.Caching;


namespace ApiDemo
{
    public partial class Employee1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        private DataCache GetCurrentCache()
        {
            var factory = new DataCacheFactory();
            DataCache dCache = factory.GetCache("default");

            return dCache;
        }

        protected void AddButton_Click(object sender, EventArgs e)
        {
            var dCache = GetCurrentCache();
            var employeeID = Convert.ToInt32(EmployeeIDTextbox.Text);
            var firstName = FirstNameTextbox.Text;
            var lastName = LastNameTextbox.Text;
            var address = AddressTextbox.Text;
            var hireDate = Convert.ToDateTime(HireDateTextbox.Text);

            var emp = new Employee
            {
                EmployeeID = employeeID,
                FirstName = firstName,
                LastName = lastName,
                Address = address,
                HireDate = hireDate
            };

            try
            {
                dCache.Add(employeeID.ToString(), emp);
                StatusLabel.Text =
                string.Format("Successfully added employee {0} to cache",
                    employeeID);
            }
            catch (Exception ex)
            {
                StatusLabel.Text =
                    string.Format("Error adding employee {0} to cache: {1}",
                        employeeID, ex.Message);
            }

        }

        protected void PutButton_Click(object sender, EventArgs e)
        {
            var dCache = GetCurrentCache();
            var employeeID = Convert.ToInt32(EmployeeIDTextbox.Text);
            var firstName = FirstNameTextbox.Text;
            var lastName = LastNameTextbox.Text;
            var address = AddressTextbox.Text;
            var hireDate = Convert.ToDateTime(HireDateTextbox.Text);

            var emp = new Employee
            {
                EmployeeID = employeeID,
                FirstName = firstName,
                LastName = lastName,
                Address = address,
                HireDate = hireDate
            };

            try
            {
                dCache.Put(employeeID.ToString(), emp);
                StatusLabel.Text =
                string.Format("Successfully added employee {0} to cache", employeeID);
            }
            catch (Exception ex)
            {
                StatusLabel.Text =
                    string.Format("Error putting employee {0} to cache: {1}", employeeID, ex.Message);
            }

        }

        protected void GetButton_Click(object sender, EventArgs e)
        {
            var dCache = GetCurrentCache();

            try
            {
                var emp = (Employee)dCache.Get(EmployeeIDTextbox.Text);
                FirstNameTextbox.Text = emp.FirstName;
                LastNameTextbox.Text = emp.LastName;
                AddressTextbox.Text = emp.Address;
                HireDateTextbox.Text = emp.HireDate.ToString();

                StatusLabel.Text =
                string.Format(
                    "Successfully did Get of employee {0} from cache",
                    emp.EmployeeID);
            }
            catch (Exception ex)
            {
                StatusLabel.Text =
            string.Format("Error getting employee {0} and {1}",
                EmployeeIDTextbox.Text, ex.Message);
            }

        }

    }
}